/**
 *Server multithread echo di ci che scrive un client
 * 
 */

import java.io.*;
import java.net.*;

class ServThread implements Runnable {

	static ServerSocket s;

	ServThread(ServerSocket ss) {
		s = ss;

	}

	public void run() {
		while (true) {
			try {
				Socket cs = s.accept();
				BufferedReader in =
					new BufferedReader(
						new InputStreamReader(cs.getInputStream()));
				PrintWriter out =
					new PrintWriter(
						new BufferedWriter(
							new OutputStreamWriter(cs.getOutputStream())));
				out.println(
					"Scrivi il messaggio e digita invio, per uscire digita 'quit'");
				out.flush();
				boolean done = false;
				while (!done) {
					String line = in.readLine();
					if (line.equalsIgnoreCase("quit"))
						done = true;
					else {
						out.println(
							"Utente: "
								+ cs.getInetAddress()
								+ " messaggio: "
								+ line);
						out.flush();
					}
				}
				cs.close();

			} catch (IOException e) {
				System.out.println("Run: " + e);
			}
		}
	}

	public static void main(String[] args) {

		try {
			int port = 3000;

			ServerSocket s = new ServerSocket(port);
			System.out.println(
				"Server " + s + " in ascolto sulla porta: " + port);
			for (int z = 0; z < 5; z++) {
				Thread t = new Thread(new ServThread(s));
				t.start();
			}

		} catch (IOException e) {
			System.out.println("Main: " + e);
		}

	}
}
