import java.io.*;
import java.util.*;

public class Magazzino {

	HashMap bibitaToLettera, letteraToBibita, statTessere, statLattine;

	LinkedList T, C, B;

	Magazzino() {
		T = new LinkedList();
		C = new LinkedList();
		B = new LinkedList();
		bibitaToLettera = new HashMap();
		letteraToBibita = new HashMap();
		statTessere = new HashMap();
		statLattine = new HashMap();
	}

	void caricaMagazzino() throws IOException {
		try {
			BufferedReader inBevande =
				new BufferedReader(new FileReader("bevande.txt"));
			String riga;
			int lettera = 97;
			while ((riga = inBevande.readLine()) != null) {

				StringTokenizer campo = new StringTokenizer(riga);

				Bibita b =
					new Bibita(
						campo.nextToken(),
						Float.parseFloat(campo.nextToken()));
				B.add(b);

				/* dal nome bevanda ho il prezzo */
				bibitaToLettera.put(b, new String(""+(char)lettera));
				letteraToBibita.put(new String("" + (char) lettera), b);
				statLattine.put(b,new Integer(0));
				lettera++;

			}
			BufferedReader inTessere =
				new BufferedReader(new FileReader("tessere.txt"));
			while ((riga = inTessere.readLine()) != null) {
				StringTokenizer campo = new StringTokenizer(riga);
				Tessera t =
					new Tessera(
						Integer.parseInt(campo.nextToken()),
						Float.parseFloat(campo.nextToken()));
				T.add(t);
				statTessere.put(t, new Float(0.0));
				
			}

			BufferedReader inColonna =
				new BufferedReader(new FileReader("colonne.txt"));
			int i = 1;
			while ((riga = inColonna.readLine()) != null) {
				StringTokenizer campo = new StringTokenizer(riga);
				Colonna c =
					new Colonna(
						campo.nextToken(),
						Integer.parseInt(campo.nextToken()),
						Integer.parseInt(campo.nextToken()),
						i);

				C.add(c);

				i++;
			}
			setColonneBibite();

		} catch (IOException e) {
			throw e;
		}
	}

	void printBevande() {
		System.out.println("Ciao utente, premi R per ricaricare la tessera, X per inserire un'altra tessera, 0 per vedere le statistiche, S per spegnere il distributore oppure scegli una bevanda");
		System.out.println("Bevande a disposizione: ");
		Iterator L = B.iterator();
		while (L.hasNext()) {
			Bibita b = (Bibita) L.next();
			System.out.println(
				bibitaToLettera.get(b)
					+ ") - "
					+ b.getNome()
					+ "	"
					+ b.getPrezzo()
					+ " Euro");

		}
	}

	void setColonneBibite() {
		Iterator lB = B.iterator();
		while (lB.hasNext()) {
			Bibita b = (Bibita) lB.next();
			Iterator lC = C.iterator();
			while (lC.hasNext()) {
				Colonna c = (Colonna) lC.next();

				if (c.getNomeBevanda().equalsIgnoreCase(b.getNome())
					&& (c.getQuantit() > 0)) {
					/* se esiste almeno una colonna con questa bevanda disponibile torna la bevanda */
					b.aggiungiColonna(c);
				}
			}
		}
	}

	Tessera ricercaTessera(int numero) {
		Iterator lT = T.iterator();
		while (lT.hasNext()) {
			Tessera t = (Tessera) lT.next();
			if (t.getNumero() == numero) {
				return t;
			}
		}
		return null;
	}

	boolean erogaBibita(String b, Tessera t) {
		Bibita bb = (Bibita) letteraToBibita.get(b);
		if(bb==null)
			return false;
		if (t.getCredito() > bb.getPrezzo()) {
			Colonna c = bb.primaColonnaConBevanda();
			if (c == null) {
				System.out.println("Bevanda Esaurita");
				return false;
			}
			if (c.prelevaBibita() == 0) {
				bb.rimuoviColonna(c);
			}
			System.out.println(
				"Bibita: "
					+ bb.getNome()
					+ " prelevata dalla colonna "
					+ c.getColonna());
			t.updateCredito(t.getCredito() - bb.getPrezzo());
			Float spesaAttuale= (Float) statTessere.get(t);
			statTessere.remove(t);
			statTessere.put(t,new Float(spesaAttuale.floatValue()+bb.getPrezzo()));
			
			Integer lattineAttuali= (Integer) statLattine.get(bb);
			statLattine.remove(bb);
			statLattine.put(bb,new Integer(lattineAttuali.intValue()+1));
			return true;
		} else {
			System.out.println("Credito insufficiente");
			return false;
		}
	}
	void statistiche()
	{
	System.out.println("Statistiche: \nTessera	Importo");
		Iterator lT = T.iterator();
		while (lT.hasNext()) {
			Tessera t = (Tessera) lT.next();
			System.out.println(t.getNumero()+"			"+((Float) statTessere.get(t)).floatValue());
		}
	System.out.println("Bibita	Lattine");
	Iterator lB = B.iterator();
		while (lB.hasNext()) {
			Bibita b = (Bibita) lB.next();
			System.out.println(b.getNome()+"		"+((Integer) statLattine.get(b)).intValue());
		}
	}
}