import java.io.*;
import java.util.*;

class BadSkiliftIdException extends Exception{};

public class Manager {

	private static String nomeFile;
	private static HashMap skilift=new HashMap();
	private static HashMap tesserati=new HashMap();

	public static void main(String[] args) {
		
		nomeFile = args[0];
		try {
			loadSkilift(nomeFile);
			loadTesserati("tesserati.txt");
			boolean loop = true;
			while (loop) {
				System.out.println("Scegli: 1)Passaggio 2)Esci");
				BufferedReader in =
					new BufferedReader(new InputStreamReader(System.in));
				int choice = 0;
				try {
					choice = Integer.parseInt(in.readLine());
				} catch (IOException ioe) {
					System.out.println("I/O error");
				} catch (NumberFormatException ioe) {
					System.out.println("Formato Errato");
					continue;
				}
				switch (choice) {
					case 1 :
						{

							try {
								long cardId = -1;
								int liftId = -1;
								System.out.print("Card ID: ");
								cardId = Integer.parseInt(in.readLine());
								System.out.print("Skilift ID: ");
								liftId = Integer.parseInt(in.readLine());
								System.out.println(
									"Result: " + auth(cardId, liftId));

							} catch (BadSkiliftIdException bsie) {
								System.out.println("Accesso proibito");
							} catch (IOException ioe) {
								System.out.println("I/O error");
							} catch (NumberFormatException nfe) {
								System.out.println("Formato Errato");
								continue;
							}
							break;
						}
					case 2 :
						{
							loop = false;
							break;
						}
				}
			}
			} catch (IOException e) {
			System.out.println(e);
		}

	}

	private static void loadTesserati(String nomeFile) throws IOException {
		try {
			BufferedReader in = new BufferedReader(new FileReader(nomeFile));
			String riga;
			Date currentDate = new Date();
			while ((riga = in.readLine()) != null) {
				tesserati.put(
					new Long(Long.parseLong(riga)),
					new Long(currentDate.getTime()));
			}
		} catch (IOException e) {
			throw e;
		}

	}

	private static void loadSkilift(String nomeFile) throws IOException {
		try {
			BufferedReader in = new BufferedReader(new FileReader(nomeFile));
			String riga;
			while ((riga = in.readLine()) != null) {
				StringTokenizer temp = new StringTokenizer(riga);
				skilift.put(
					new Integer(Integer.parseInt(temp.nextToken(","))),
					new Long(Long.parseLong(temp.nextToken(","))));
			}
		} catch (IOException e) {
			throw e;
		}
	}

	private static boolean auth(long cardId, int skiliftId) throws BadSkiliftIdException {
		Date currentDate = new Date();
		Long timeTessera, ritardo;
		timeTessera = (Long) tesserati.get(new Long(cardId));
		ritardo = (Long) skilift.get(new Integer(skiliftId));
		if(timeTessera==null)
		{System.out.println("Tessera non valida");
			return false;
		}
		BadSkiliftIdException e = new BadSkiliftIdException();
		System.out.println("time tessera "+timeTessera.longValue());
		if ((currentDate.getTime()-timeTessera.longValue())> ritardo.longValue()*1000) {
			tesserati.put(new Long(cardId), new Long(currentDate.getTime()));
			return true;
		} else
			throw e;
	}
}

